/* 
This code and design is written and copyright protected by Marco Janc.
Usage of any code parts or files included in this package are forbidden
unless you have been granted the rights to use them by the above mentioned author.
*/

// --------------------------------------------------------------------
//global variables
// --------------------------------------------------------------------
var numOfSearchEngines = 5;
var backGroundDockStateSize = new Array ( new Array (130, 67), new Array (264, 194));
var engMiniPrevDockStateSize = new Array  (12, 18);

// --------------------------------------------------------------------
//This function removes all
//unnecessary Spaces at the  
//beginning and end of a String.
// --------------------------------------------------------------------
String.prototype.trim = function () {
    return this.replace(/^\s+/g, '').replace(/\s+$/g, '');
}

// --------------------------------------------------------------------
// initialize gadget
// --------------------------------------------------------------------
document.onreadystatechange = function()
{    
	if(document.readyState == "complete")
	{
		System.Gadget.settingsUI = "win7_gadget_search_google_settings.html";
		System.Gadget.onSettingsClosed = settingsClosed;
    	System.Gadget.Flyout.file = "win7_gadget_search_google_flyout.html";
		System.Gadget.onUndock = resizeGadget;
		System.Gadget.onDock = resizeGadget;
		readValues();
	}
}
// --------------------------------------------------------------------
// Handle the Settings dialog closed event.
// Parameters:
// event - event arguments.
// --------------------------------------------------------------------
function settingsClosed(event)
{
	// User hits OK on the settings page.
	if (event.closeAction == event.Action.commit) { readValues(); }
}
// --------------------------------------------------------------------
// Displays the Switch Engine Dialog
// --------------------------------------------------------------------
function showSwitchEngineDialog(id)
{
	toggleSwitchEngineDialogDisplay(id, true)
}
function hideSwitchEngineDialog(id)
{
	toggleSwitchEngineDialogDisplay(id, false) 
}

function toggleSwitchEngineDialogDisplay(id, show) 
{
	var obj = document.getElementById(id);
	var displayInvert;
	if (show) { 
		obj.style.display = "block";
		displayInvert = "none";
	}
	else { 
		obj.style.display = "none"; 
		displayInvert = "block";
	}
	document.getElementById("mainLink").style.display = displayInvert;
	document.getElementById("optionsId").style.display = displayInvert;

}
// --------------------------------------------------------------------
// Displays the Switch Engine Dialog
// object - img object which border has to be set
// --------------------------------------------------------------------
function switchEngineByImg(object)
{
	//get object index
	var index = 0;
	var element = object.parentNode.getElementsByTagName("img");
	for (index; index < element.length; index++) 
	{
		if (object.id == element[index].id) { break; }
	}
	resetEngineImg(object, index);
	System.Gadget.Settings.writeString("searchEngineIndex", index);
	setSearchEngine();
	hideSwitchEngineDialog('switchEngineId1');
}

function resetEngineImg(object, index)
{
	var element = object.parentNode.getElementsByTagName("img");
	//colour all engine images border with default color
	for (i = 0; i < element.length; i++) 
	{
		element[i].style.borderColor = "ccccbc"; //object.style.borderColor 808075
	}
	element[index].style.borderColor = "ebaa1d";//"FFFFE1";
}



// --------------------------------------------------------------------
// Set the current search engine by its saved parameter
// --------------------------------------------------------------------
function setSearchEngine()
{
	//google video needs to be used by subdomain, so we create an array with all subdomains
	//still cse images are usable without subdomain
	var googleURLs = new Array ("http://www.google.com/cse", 
		"http://www.google.com/search", 
		"http://images.google.com/images",
		"http://video.google.com/videosearch",
		"http://maps.google.de/maps");

	//set all input options
	readSettingInputValues()

	//get Engine select img 
	var imgEngine = null;
	
	//get and set search engine related settings		//isNaN("4564")    => false 
	var searchEngineIndex = System.Gadget.Settings.readString("searchEngineIndex");
	
	
	document.submitForm.t.disabled = true;
	document.submitForm.mrt.disabled = true;
	//for case no settings have been saved since yet, little redundant
	
	//case 0 <- google custom search
	if (searchEngineIndex != "") //  && && !isNan(searchEngineIndex) && searchEngineIndex < enginesParam.length 
	{
		//case 1 <- original google search
		if (searchEngineIndex > 0)
		{
			document.submitForm.cx.disabled = true;
			document.submitForm.cof.disabled = true;
			//case 2 <- google image search
			if (searchEngineIndex > 1)
			{
				document.submitForm.num.disabled = true;
				if (searchEngineIndex > 2)
				{
					//case 3 <- google video search
					engineBugDisable(true);
					//case 4 <- google map search
					if (searchEngineIndex > 3)
					{
						if (document.submitForm.t.value != "") { document.submitForm.t.disabled = false; }
						if (document.submitForm.mrt.value != "") { document.submitForm.mrt.disabled = false; }
					}
				}
			}
		}
		//set new form action
		document.submitForm.action = googleURLs[searchEngineIndex];
	}
 	else
 	{
 		document.submitForm.action = googleURLs[0];	//default cse search
 		searchEngineIndex = 0; //necessary for below function
 	}

	//reset engine selection border style of image
 	resetEngineImg(document.getElementById("imgEng" + searchEngineIndex), searchEngineIndex);
 	setEngineMiniPreviewImg();
}
// --------------------------------------------------------------------
// selects the next search engine
// --------------------------------------------------------------------
function setNextSearchEngine()
{
	//get searchEngineIndex
	var searchEngineIndex = System.Gadget.Settings.readString("searchEngineIndex");
	if (searchEngineIndex != "") 
	{ 
		if(searchEngineIndex == numOfSearchEngines - 1) { searchEngineIndex = 0; }
		else { searchEngineIndex++; }
	}
	else { searchEngineIndex = 1; }
	System.Gadget.Settings.writeString("searchEngineIndex", searchEngineIndex);
	setSearchEngine();
}
// --------------------------------------------------------------------
// sets the mini engine preview image regarding the saved
// engine index
// --------------------------------------------------------------------
function setEngineMiniPreviewImg()
{
	var imgDiskNames = new Array ("cse", "orig", "image", "video", "map");
	var imgTitles = new Array ("Custom Google Search", "Original Google Search", "Google Image Search", "Google Video Search", "Google Map Search");
	var objEngMiniPrev = document.getElementById("engineMiniPreview");
	
	//get searchEngineIndex
	var searchEngineIndex = System.Gadget.Settings.readString("searchEngineIndex");
	if (searchEngineIndex == "") { searchEngineIndex = 0; }
	var sizeIndex = 0;
	if (!System.Gadget.docked) { sizeIndex = 1; }
	objEngMiniPrev.style.backgroundImage = "url(../images/controls/engines/win7_search_gadget_google_" + imgDiskNames[searchEngineIndex] + "_" + engMiniPrevDockStateSize[sizeIndex] + "x" + engMiniPrevDockStateSize[sizeIndex] + ".png)"; 
	objEngMiniPrev.title = imgTitles[searchEngineIndex];
	objEngMiniPrev.style.width = objEngMiniPrev.style.height = engMiniPrevDockStateSize[sizeIndex];
}
// --------------------------------------------------------------------
// Load Background image regarding docked or undocked state
// docked - boolean represents docked style of gadget
// --------------------------------------------------------------------
function setBackground()
{
	var objBackground = document.getElementById("imgBackground");
	objBackground.style.width = 0;
	objBackground.style.height = 0;
	
	//gadget dock state
	var dockSatateIndex = 0;
	if (!System.Gadget.docked) { dockSatateIndex = 1; }
	
	//get and set backgroundimage
	var gadgetBgIndex = System.Gadget.Settings.readString("gadgetBgIndex");
	if (gadgetBgIndex != "") 
	{
		if (gadgetBgIndex < 10) { gadgetBgIndex = "0" + gadgetBgIndex; }
		objBackground.src = "url(../images/background/win7_search_gadget_google_background_" + backGroundDockStateSize[dockSatateIndex][0] + "x" + backGroundDockStateSize[dockSatateIndex][1] + "_" + gadgetBgIndex + ".png)";
	}
	else { objBackground.src = "url(../images/background/win7_search_gadget_google_background_" + backGroundDockStateSize[dockSatateIndex][0] + "x" + backGroundDockStateSize[dockSatateIndex][1] + "_00.png)"; }
	document.body.style.width = backGroundDockStateSize[dockSatateIndex][0];
	document.body.style.height = backGroundDockStateSize[dockSatateIndex][1];

}
// --------------------------------------------------------------------
// Load and set all gadget related settings
// --------------------------------------------------------------------
function readValues()
{
	//get and set backgroundimage
	setBackground();
	//get and set searchEngine settings
	setSearchEngine();
	//set all input values
	readSettingInputValues();
}
// --------------------------------------------------------------------
// Load and set all docked state input settings
// --------------------------------------------------------------------
function readSettingInputValues()
{
	//get current search engine
	var searchEngineIndex = System.Gadget.Settings.readString("searchEngineIndex");
	if (searchEngineIndex == "") { searchEngineIndex = 0; }
	
	//get and set hl value
	var hlValue = System.Gadget.Settings.readString("hlValue");
 	if (hlValue != "") 
 	{ 
 		document.submitForm.hl.disabled = false; 
 		document.submitForm.hl.value = hlValue; 
 	}
 	else { document.submitForm.hl.disabled = true; }
 	//get and set lr value
	var lrValue = System.Gadget.Settings.readString("lrValue");
 	if (lrValue != "") 
 	{ 
 		document.submitForm.lr.disabled = false;
 		document.submitForm.lr.value = "lang_" + lrValue; 
 	}
 	else
 	{
 		document.submitForm.lr.disabled = true;
 		document.submitForm.lr.value = ""; 
 	}
 	//get and set safe value
	var safeValue = System.Gadget.Settings.readString("safeValue");
 	if (safeValue != "") 
 	{ 
 		document.submitForm.safe.disabled = false; 
 		document.submitForm.safe.value = safeValue;
 	}
 	else { document.submitForm.safe.disabled = true; }
 	//get and set num value
	var numValue = System.Gadget.Settings.readString("numValue");
 	if (numValue != "")
 	{ 
 		document.submitForm.num.disabled = false; 
 		document.submitForm.num.value = numValue; 
 	}
 	else  { document.submitForm.num.disabled = true; }
 	//get and set num value
	var newwindowValue = System.Gadget.Settings.readString("newwindowValue");
 	if (newwindowValue != "") 
 	{ 
 		document.submitForm.newwindow.disabled = false; 
 		document.submitForm.newwindow.value = newwindowValue;
 	}
 	else { document.submitForm.newwindow.disabled = true; }
 	
 	//cse search engine
 	if (searchEngineIndex == 0) 
 	{
 		//get themeIndex 
	 	var themeIndex = System.Gadget.Settings.readString("themeIndex");
	 	//default needs no design
	 	if (themeIndex != 1) 
	 	{
	 		//get and set cof value
		 	var cofValue = System.Gadget.Settings.readString("cofValue");
		 	if (cofValue != "") 
		 	{ 
		 		document.submitForm.cof.disabled = false; 
		 		document.submitForm.cof.value = cofValue; 
		 	}
		 	else { document.submitForm.cof.disabled = true; }
	 	}
	 	else { document.submitForm.cof.disabled = true; }
 	}
 	//map search engine
 	else if (searchEngineIndex == 4) 
 	{
 		//get and set mrt value
	 	var mrtValue = System.Gadget.Settings.readString("mrtValue");
	 	if (mrtValue != "") 
	 	{ 
 			document.submitForm.mrt.value = mrtValue;
	 		document.submitForm.mrt.disabled = false; 
	 	}
	 	else { document.submitForm.mrt.disabled = true; }
	 	//get and set t value
	 	var tValue = System.Gadget.Settings.readString("tValue");
	 	if (tValue != "") 
	 	{ 
	 		document.submitForm.t.disabled = false; 
	 		document.submitForm.t.value = tValue; 
	 	}
	 	else { document.submitForm.t.disabled = true; }
 	}

}
// ------------------------------------------------------------------------------------
// checks wether we have to open it in a new webbrowser or in the flyout menu
// ------------------------------------------------------------------------------------
function checkForFlyout() 
{
	if (document.submitForm.q.value.trim() != "") 
	{
		engineBugDisable(false);
		
		//get flyout state
		var flyOutChecked = System.Gadget.Settings.read("flyOutChecked");
		if (flyOutChecked != "") 
		{ 
			if (flyOutChecked == false) { return true; }
			//open flyout
			else 
			{
				//save valus
				if (System.Gadget.docked) 
				{
					System.Gadget.Settings.writeString("q", document.submitForm.q.value.trim());
				}
				else 
				{
					System.Gadget.Settings.writeString("as_q", document.submitForm.as_q.value.trim());
					System.Gadget.Settings.writeString("as_epq", document.submitForm.as_epq.value.trim());
					System.Gadget.Settings.writeString("as_eq", document.submitForm.as_eq.value.trim());
				}
				//but only if searchengine is cse or maps
				//images and videos should not be searchable in flyout
				var searchEngineIndex = System.Gadget.Settings.readString("searchEngineIndex");
				if (searchEngineIndex == 0 || searchEngineIndex == 4) 
				{
					System.Gadget.Flyout.show = true;
					return false;
				}
				else 
				{
					return true;
				}
			}	
		}
		else { return true; }
	}
	else { return false; }
}

// --------------------------------------------------------------------
// fired after we have submitted the form
// --------------------------------------------------------------------
function afterSubmit()
{
	//update video engine bug
	engineBugDisable(true);
}

// --------------------------------------------------------------------
// disables or enables all video Engine google bug input fields
// if param enable is true the field will be disabled
// enable - boolean wether the q input field should be enabled
// --------------------------------------------------------------------
function engineBugDisable(enable)
{
		//video search does not work with as_q, as_epq, as_eq inputs
		//google video site bug 
		//only works with q value
		//map search does not work either, but at maps its no bug
		var searchEngineIndex = System.Gadget.Settings.readString("searchEngineIndex");
		if (!System.Gadget.docked && (searchEngineIndex == 3 || searchEngineIndex == 4))
		{
			document.submitForm.q.disabled = enable;
			document.submitForm.q.readOnly = enable;
			document.submitForm.as_q.disabled = !enable;
			document.submitForm.as_epq.disabled = !enable;
			document.submitForm.as_eq.disabled = !enable;
		}
}


// --------------------------------------------------------------------
// toggle textbox query properties related to 
// the gadget docking state
// --------------------------------------------------------------------
function toggleTextBoxGadgetState()
{
	if (System.Gadget.docked) 
	{
		//update q value
		updateQuery();
		//additional textboxes
		document.submitForm.as_q.disabled = true;
		document.submitForm.as_epq.disabled = true;
		document.submitForm.as_eq.disabled = true;
		//reset all fields
		document.submitForm.as_q.value = "";
		document.submitForm.as_epq.value = "";
		document.submitForm.as_eq.value = "";
		//query textbox
		document.submitForm.q.readOnly = false;
		document.submitForm.q.disabled = false;
		document.submitForm.q.style.width = "62%"
		document.submitForm.q.style.backgroundColor = "#d9d9d9";
	}
	else
	{
		//additional textboxes
		document.submitForm.as_q.disabled = false;
		document.submitForm.as_epq.disabled = false;
		document.submitForm.as_eq.disabled = false;
		//query textbox
		document.submitForm.q.readOnly = true;
		document.submitForm.q.disabled = true;
		document.submitForm.q.style.width = "75%"
		document.submitForm.q.style.backgroundColor = "#cde7f4";
		//update additional textbox values
		extractQueryParams();
	}
}

// --------------------------------------------------------------------
// resize the Gadget from docked to undocked mode
// --------------------------------------------------------------------
function resizeGadget()
{
	System.Gadget.beginTransition();
		
	setBackground();
	toggleTextBoxGadgetState();
	
	var objMainLink = document.getElementById("mainLink");
	var objOptionsId = document.getElementById("optionsId");
	var objOptionsUndock = document.getElementById("optionsUndocked");
	var objEngSel = document.getElementById("switchEngineId1");
	var objEng4 = document.getElementById("imgEng4");


	if (System.Gadget.docked) 
	{
		//mainLink
		objMainLink.style.fontSize = 18;
		objMainLink.style.left = "25%";
		objMainLink.style.top = "15%";
		//optionsId
		objOptionsId.style.top = "52%"//-17;
		//objOptionsUndock
		objOptionsUndock.style.visibility = "hidden";
		//objEngSel
		objEngSel.style.left = "5%";
		objEngSel.style.top = "23%";
		//objEng4
		objEng4.style.display = "none";
	}
	else 
	{
		//mainLink
		objMainLink.style.fontSize = 30;
		objMainLink.style.left = "30%";
		objMainLink.style.top = "13%";
		//optionsId
		objOptionsId.style.top = "34%"//-17;
		//objOptionsUndock
		objOptionsUndock.style.visibility = "visible";
		//objEngSel
		objEngSel.style.left = "25%";
		objEngSel.style.top = "15%";
		//objEng4
		objEng4.style.display = "block";
	}
	//update Engine Mini preview image
	setEngineMiniPreviewImg();
	System.Gadget.endTransition(System.Gadget.TransitionType.morph, 2);
}


// --------------------------------------------------------------------
// extracts all "sample1" -sample2 -"sample3 sample3" queries 
// to fill the textboxes
// --------------------------------------------------------------------
function extractQueryParams()
{
	/*
	var query = document.submitForm.q.value.trim();
	
	//search for quotations 
	var quotReg = new RegExp("(\"|\')[^\"\']*(\"|\')", "g"); //is
	var quotations;
	while (quotations = quotReg.exec(query))
	{	
		if (quotations.index >= 0 && query.charAt(quotations.index - 1) != "-") 	//no lookbehind in javascript
		{
			var match = quotations[0].trim();
			document.submitForm.as_epq.value += match.substring(1, match.length - 1).trim() + " ";
		} 
	}
	//search for exclusions 		//|[\S]* <- doesnt works strangely
	var exclReg = new RegExp("-((\"|\')[^(\"|\')]*(\"|\'))|(.)*[^\-\W\"\']", "g"); //is
	var exclusions;
	while (exclusions = exclReg.exec(query))
	{
		document.submitForm.as_eq.value += exclusions[0].trim().substring(1) + " ";
	}

	//get normal text by reducing found results from query;
	*/
	
	document.submitForm.as_q.value = document.submitForm.q.value.trim();
}

// --------------------------------------------------------------------
// updates the main query textbox with all additional parameters
// --------------------------------------------------------------------
function updateQuery()
{
	var query = document.submitForm.as_q.value + " ";//.trim();
	var as_epqValue = document.submitForm.as_epq.value.trim();
	var as_eqValue = document.submitForm.as_eq.value.trim();
	
	if (as_epqValue != "") { query += '"' + as_epqValue + '" '; }
	if (as_eqValue != "") 
	{ 
		var as_eqValueSplit = as_eqValue.split(" ");
		for(i = 0; i < as_eqValueSplit.length; i++) { query += "-" + as_eqValueSplit[i] + " "; }
	}
	document.submitForm.q.value = query.trim();
}