/* 
This code and design is written and copyright protected by Marco Janc.
Usage of any code parts or files included in this package are forbidden
unless you have been granted the rights to use them by the above mentioned author.
*/

// --------------------------------------------------------------------
//global variables
// --------------------------------------------------------------------
var themeDefault = new Array ("cccccc", "ffffff", "0000cc", "000000", "008000", "551A8B");

//initialize values
document.onreadystatechange = function()
{    
	if(document.readyState == "complete")
    {
    	// Delegate for the settings closing event. 
		System.Gadget.onSettingsClosing = settingsClosing;
		
		//get flyout state
		var flyOutChecked = System.Gadget.Settings.read("flyOutChecked");
		if (flyOutChecked == true) { flyOut.checked = true; }
     	else { flyOut.checked = false; }
		//get background image index and set preview
		var gadgetBgIndex = System.Gadget.Settings.readString("gadgetBgIndex");
     	if (gadgetBgIndex != "") 
     	{ 
     		mainBgImg[gadgetBgIndex].selected = true;
     		imgBgPreview(gadgetBgIndex, "mainBgImgPrev");
     	
     	}
     	else 
     	{  
     		mainBgImg[0].selected = true; 
     		imgBgPreview(0, "mainBgImgPrev");
     	}
		//get search engine index and set selected item in list
		var searchEngineIndex = System.Gadget.Settings.readString("searchEngineIndex");
     	if (searchEngineIndex != "") { searchEngine[searchEngineIndex].selected = true; }
     	else { searchEngine[0].selected = true; }
     	//get hl index
		var hlIndex = System.Gadget.Settings.readString("hlIndex");
     	if (hlIndex != "") { hl[hlIndex].selected = true; }
     	else { hl[0].selected = true; }
     	//get lr index
		var lrIndex = System.Gadget.Settings.readString("lrIndex");
     	if (lrIndex != "") { lr[lrIndex].selected = true; }
     	else { lr[0].selected = true; }
     	//get safe index
		var safeIndex = System.Gadget.Settings.readString("safeIndex");
     	if (safeIndex != "") { safe[safeIndex].selected = true; }
     	else { safe[0].selected = true; }
     	//get num index
		var numIndex = System.Gadget.Settings.readString("numIndex");
     	if (numIndex != "") { num[numIndex].selected = true; }
     	else { num[0].selected = true; }
     	//get num index
		var newwindowIndex = System.Gadget.Settings.readString("newwindowIndex");
     	if (newwindowIndex != "") { newwindow[newwindowIndex].selected = true; }
     	else { newwindow[0].selected = true; }
     	//get themeIndex
		var themeIndex = System.Gadget.Settings.readString("themeIndex");
     	if (themeIndex != "") { theme[themeIndex].selected = true; }
     	else { theme[1].selected = true; }
     	//------------------------------------------------------
     	//get cof values only if theme is none
     	//------------------------------------------------------
     	if (theme.selectedIndex == 0) 
     	{
     		//get background color
     		var bgColorValue = System.Gadget.Settings.readString("BGC");
     		if (bgColorValue != "") { bgColor.value = bgColorValue; }
     		//get text color
     		var tColorValue = System.Gadget.Settings.readString("T");
     		if (tColorValue != "") { tColor.value = tColorValue; }
     		//get link color
     		var lColorValue = System.Gadget.Settings.readString("LC");
     		if (lColorValue != "") { lColor.value = lColorValue; }
     		//get visited link color
     		var vlColorValue = System.Gadget.Settings.readString("VLC");
     		if (vlColorValue != "") { vlColor.value = vlColorValue; }
     		//get url color
     		var urlColorValue = System.Gadget.Settings.readString("GALT");
     		if (urlColorValue != "") { urlColor.value = urlColorValue; }
     		//get div color
     		var divColorValue = System.Gadget.Settings.readString("DIV");
     		if (divColorValue != "") { divColor.value = divColorValue; }
     		//get logo image url
     		var logoImgUrlValue = System.Gadget.Settings.readString("L");
     		if (logoImgUrlValue != "") 
     		{ 
     			logoImgUrl.value = logoImgUrlValue;
     			imgPreview(logoImgUrl.value, "logoImgPrev"); 
     		}
     		//get background image url
     		var bgImgUrlValue = System.Gadget.Settings.readString("BIMG");
     		if (bgImgUrlValue != "") 
     		{ 
     			bgImgUrl.value = bgImgUrlValue; 
     			imgPreview(bgImgUrl.value, "bgImgPrev");
     		}
     	}
     	//google map parameters
     	//location
		var mrtIndex = System.Gadget.Settings.readString("mrtIndex");
     	if (mrtIndex != "") { mrt[mrtIndex].selected = true; }
     	else { mrt[0].selected = true; }
     	//map display style
     	var tIndex = System.Gadget.Settings.readString("tIndex");
     	if (tIndex != "") { t[tIndex].selected = true; }
     	else { t[0].selected = true; }
     	
     	toggleFlyOutRelated();
     	//is called in flyout toggleCseOptions();
     	changeTheme(theme.selectedIndex);
     	
	}
}
   
	
// --------------------------------------------------------------------
// Handle the Settings dialog closing event.
// Parameters:
// event - event arguments.
// --------------------------------------------------------------------
function settingsClosing(event)
{
	// Save the settings if the user clicked OK.
	if (event.closeAction == event.Action.commit)
	{
		System.Gadget.Settings.write("flyOutChecked", flyOut.checked);
		System.Gadget.Settings.writeString("gadgetBgIndex", mainBgImg.selectedIndex);
		System.Gadget.Settings.writeString("searchEngineIndex", searchEngine.selectedIndex);
		System.Gadget.Settings.writeString("hlValue", hl.value);
		System.Gadget.Settings.writeString("hlIndex", hl.selectedIndex);
		System.Gadget.Settings.writeString("lrValue", lr.value);
		System.Gadget.Settings.writeString("lrIndex", lr.selectedIndex);
		System.Gadget.Settings.writeString("safeValue", safe.value);
		System.Gadget.Settings.writeString("safeIndex", safe.selectedIndex);
		System.Gadget.Settings.writeString("numValue", num.value);
		System.Gadget.Settings.writeString("numIndex", num.selectedIndex);
		System.Gadget.Settings.writeString("newwindowValue", newwindow.value);
		System.Gadget.Settings.writeString("newwindowIndex", newwindow.selectedIndex);
		
		//save custom engine related settings
		if (searchEngine.selectedIndex == 0) //1 is default theme no need to save
		{
			System.Gadget.Settings.writeString("themeIndex", theme.selectedIndex);
		
			if (theme.selectedIndex != 1)
			{
				//get values and create and save cof value
				//save single values redudant seperately
				//less performance cost later hence no string extraction is needed
				var cof = ""
				if (bgColor.value != "") 
				{ 
					cof += "BGC:" + bgColor.value + ";"; 
					System.Gadget.Settings.writeString("BGC", bgColor.value);
				}
				if (tColor.value != "") 
				{ 
					cof += "T:" + tColor.value + ";"; 
					System.Gadget.Settings.writeString("T", tColor.value);
				}
				if (lColor.value != "") 
				{ 
					cof += "LC:" + lColor.value + ";"; 
					System.Gadget.Settings.writeString("LC", lColor.value);
				}
				if (vlColor.value != "") 
				{ 
					cof += "VLC:" + vlColor.value + ";"; 
					System.Gadget.Settings.writeString("VLC", vlColor.value);
				}
				if (urlColor.value != "") 
				{ 
					cof += "GALT:" + urlColor.value + ";"; 
					System.Gadget.Settings.writeString("GALT", urlColor.value);
				}
				if (divColor.value != "") 
				{ 
					cof += "DIV:" + divColor.value + ";"; 
					System.Gadget.Settings.writeString("DIV", divColor.value);
				}
				if (logoImgUrl.value != "") //check for valid image
				{ 
					cof += "L:" + logoImgUrl.value + ";";
					System.Gadget.Settings.writeString("L", logoImgUrl.value);
				}
				if (bgImgUrl.value != "") //check for valid image
				{ 
					cof += "BIMG:" + bgImgUrl.value + ";"; 
					System.Gadget.Settings.writeString("BIMG", bgImgUrl.value);
				}
				if (cof != "") { System.Gadget.Settings.writeString("cofValue", cof); }
			}
		}
		else if (searchEngine.selectedIndex == 4) 
		{
			System.Gadget.Settings.writeString("mrtIndex", mrt.selectedIndex);
			System.Gadget.Settings.writeString("mrtValue", mrt.value);
			System.Gadget.Settings.writeString("tIndex", t.selectedIndex);
			System.Gadget.Settings.writeString("tValue", t.value);
		}
	}
	// Allow the Settings dialog to close.
	event.cancel = false;
}

// --------------------------------------------------------------------
// Toggle visibility of cse options
// --------------------------------------------------------------------
function toggleCseOptions()
{
	var cseOptFieldSet = document.getElementById("cseOptions");
	var mapOptFieldSet = document.getElementById("mapOptions");
	cseOptFieldSet.style.display = "none"; 
	mapOptFieldSet.style.display = "none"; 

	switch (searchEngine.selectedIndex) 
	{
		//cse
		case 0:	cseOptFieldSet.style.display = "block"; 
				break;
		//map
		case 4: mapOptFieldSet.style.display = "block";
				break;
		default: break;
	}
}

// --------------------------------------------------------------------
// set color in color preview box
// --------------------------------------------------------------------
function colorPreview(inputValue, div) 
{
	document.getElementById(div).style.backgroundColor = "#" + inputValue;
}
// --------------------------------------------------------------------
// update all color preview boxes
// --------------------------------------------------------------------
function updateColorPreviews()
{
	colorPreview(bgColor.value, "bgcPrev");
	colorPreview(tColor.value, "tcPrev");
	colorPreview(lColor.value, "lcPrev");
	colorPreview(vlColor.value, "vlcPrev");
	colorPreview(urlColor.value, "urlcPrev");
	colorPreview(divColor.value, "divcPrev");
}

// --------------------------------------------------------------------
// show image in respective div
// --------------------------------------------------------------------
function imgPreview(imageUrl, div)
{
	document.getElementById(div).src = imageUrl;
}

// --------------------------------------------------------------------
// show image background in respective div
// --------------------------------------------------------------------
function imgBgPreview(imageIndex, div)
{
	var size = new Array ( new Array (130, 67), new Array (264, 194));
	if (imageIndex < 10) { imageIndex = "0" + imageIndex; }
	var dockState = 0;
	var resizeBig = 0;	//big image needs to be resized to fit into the settings dialog
	if (!System.Gadget.docked) { 
		dockState = 1;
		resizeBig = -20;
	}
	var obj = document.getElementById(div);
	obj.src = "../images/background/win7_search_gadget_google_background_" + size[dockState][0] + "x" + size[dockState][1] + "_" + imageIndex + ".png";
	obj.style.width = size[dockState][0] + resizeBig;
	obj.style.height = size[dockState][1] + resizeBig;
}

// --------------------------------------------------------------------
// update result preview
// --------------------------------------------------------------------
function updateResultPreview()
{
	document.getElementById("previewDiv").style.borderColor = "#" + divColor.value;
	document.getElementById("previewDiv").style.backgroundColor = "#" + bgColor.value;
	document.getElementById("previewTitle1").style.color = "#" + lColor.value;
	document.getElementById("previewText1").style.color = document.getElementById("previewText2").style.color = "#" + tColor.value;
	document.getElementById("previewUrl1").style.color = document.getElementById("previewUrl2").style.color ="#" + urlColor.value;
	document.getElementById("previewTitle2").style.color = "#" + vlColor.value;
}

// --------------------------------------------------------------------
// change theme
// --------------------------------------------------------------------
function changeTheme(selectedIndex)
{
	//  name      = new Array {divider, background, link, text, url, visited link};
	var themeNone = new Array (divColor.value, bgColor.value, lColor.value, tColor.value, urlColor.value, vlColor.value);
	//theme default is global variable;
	var themeGreenBlue = new Array ("cfcfcf", "f9f8f8", "0065A4", "3d382b", "818f15", "551A8B");
	var themeBlack = new Array ("f7f7f7", "262626", "f7f7f7", "b3b3b3", "738013", "40848a");
	var themePinkBlue = new Array ("000000", "ffffff", "008ED8", "444444", "ff0099", "551A8B");
	var themeBlackRed = new Array ("f7f7f7", "262626", "f7f7f7", "b3b3b3", "eb1c00", "8f29eb");
	var themeBlackBlue = new Array ("f2f1f1", "262626", "005cc4", "8c9f8c", "f8b832", "606a76");
	var themeIce = new Array ("cfcfcf", "e4ebee", "326070", "1f1f1f", "dfac43", "674698");
	var themeDarkOrangeRed = new Array ("f7f7f7", "262626", "f8b832", "b3b3b3", "eb1c00", "8f29eb");
	
	
	var themes = new Array (themeNone, themeDefault, themeGreenBlue, themeBlack, themePinkBlue, themeBlackRed, themeBlackBlue, themeIce, themeDarkOrangeRed);
	
	divColor.value = themes[selectedIndex][0];
	bgColor.value = themes[selectedIndex][1];
	lColor.value = themes[selectedIndex][2];
	tColor.value = themes[selectedIndex][3];
	urlColor.value = themes[selectedIndex][4];
	vlColor.value = themes[selectedIndex][5];
	
	updateResultPreview();
	updateColorPreviews();
	
	if (selectedIndex == 0)
	{ 
		document.getElementById("fieldsetColorId").style.display = "block";
		if (flyOut.checked != true) { document.getElementById("fieldsetImagesId").style.display = "block"; }
	}
	else 
	{ 
		document.getElementById("fieldsetColorId").style.display = "none";
		if (flyOut.checked != false) { document.getElementById("fieldsetImagesId").style.display = "none"; }
	}
}


// --------------------------------------------------------------------
// toggle flyout related properties
// --------------------------------------------------------------------
function toggleFlyOutRelated()
{
	var objFieldsetImagesId = document.getElementById("fieldsetImagesId");
	if (flyOut.checked == true) 
	{ 
		objFieldsetImagesId.style.display = "none";
		newwindow.disabled = true;
		num.disabled = true;
		var searchEngineIndex = searchEngine.selectedIndex;
		//set default selection if engine is not cse or map
		searchEngine[1].disabled = true; //orig
		searchEngine[2].disabled = true; //images
		searchEngine[3].disabled = true; //videos
		if (searchEngineIndex != 0 && searchEngine.selectedIndex != 4) { searchEngine[0].selected = true; }
	}
	else 
	{ 
		objFieldsetImagesId.style.display = "block";
		newwindow.disabled = false;
		num.disabled = false;
		searchEngine[1].disabled = false; //orig
		searchEngine[2].disabled = false; //images
		searchEngine[3].disabled = false; //videos
	}
	toggleCseOptions();
}